<?php

/**
 * @file
 * Includes description of hooks available in the module.
 */

/**
 *
 */
function hook_sharepoint_rest_entity_mapping() {
  $entity_map = array();
  $entity_map[] = array(
    'sharepoint' => array(
      'list_type' => 'publications',
    ),
    'drupal' => array(
      'entity_type' => 'node',
      'entity_bundle' => 'resource',
    ),
    'field_map' => array(
      'description' => 'body',
      'content_type' => 'field_resource_content_type',
      'document_type' => 'field_resource_document_type',
      'locations' => 'field_resource_locations',
    ),
    'property_map' => array(
      'title' => 'title',
    )
  );

  return $entity_map;
}

/**
 * Return a filter string, which will be passed into the query to SP.
 *
 * @param $change object
 *    The change object.
 * @return string The filter string
 *    The filter string.
 */
function hook_sharepoint_rest_pull_changes_filter($change) {
  $filter = 'Id eq ' . $change->ItemId;
  $filter .= ' and External eq 1';
  return $filter;
}

/**
 * Is invoked when pulling from SP and the item has been deleted.
 * 
 * @param $map_entity object
 *   The mapping entity between SP and DP
 */
function hook_sharepoint_rest_pull_entity_delete($map_entity) {
  $dp_entity = entity_load_single($map_entity->entity_type, $map_entity->entity_id);
  $dp_entity->status = 0;
  // Set a flag to know it was saved from sync
  $dp_entity->sharepoint_migrate_flag = TRUE;
  entity_save($map_entity->entity_type, $dp_entity);
}
